# Conception du projet FME

Le projet Writers PCRS, permettant l'écriture des données PCRS dans le format GML, nécessite un minimum de connaissances dans l'utilisation du logiciel FME.

Le produit Writers PCRS correspond dans FME à 31 Transformers personnalisés. A l'exception de quelques Transformers de fonctionnement, chaque Transformer personnalisé est associé à une classe du standard PCRS.

## Prérequis

**Version FME**

La version minimale de FME à utiliser est la 2016.1.3.2.

**Limitations**

Actuellement, seules les données vectorielles sont supportées par PCRS pour FME et il n'est possible de générer qu'une emprise par document GML.

## Installation

**Installation de l'extension PCRS pour FME Desktop**

Suite à l'installation de l'extension PCRS pour FME, vous disposerez d'une trentaine de transformers supplémentaires correspondant aux classes du PCRS (PCRS_MarcheEscalierPCRS, PCRS_AffleurantPCRS...) et à des fonctions utilitaires (PCRS_MergePCRSObjects...).

Ces transformers sont regroupés dans la catégorie PCRS de la galerie des Transformers de FME et commencent tous par le préfixe PCRS_. Il vous suffit donc de taper ces lettres dans l'espace de travail de FME Workbench pour en obtenir la liste et pouvoir sélectionner le Transformer de votre choix.

**Licence PCRS pour FME**

L'extension PCRS pour FME est protégée par un fichier de licence.
Vous pouvez effectuer une demande de licence auprès de codes@veremes.com en fournissant votre code machine/registration key (n° à 10 chiffres visible dans l'utilitaire FME Licensing Assistant).

En l'absence de fichier de licence, les Transformers fonctionnent correctement mais ne laissent passer que 20 entités par classe et 500 au total.

**Installation de l'extension PCRS pour FME Server**

- Installer les Transformers personnalisés de l'extension PCRS dans les ressources FME Server.

Exécuter l'installeur PCRS. A la question de l'emplacement du dossier FME, définir le chemin du moteur FME de FME Server (par défaut "C:\Program Files\FMEServer\Server\fme" sous Windows). Suite à cette étape, les Transformers PCRS sont alors visibles dans le répertoire "\fme\transformers".
Attention, nous conseillons de choisir un chemin indépendant de FME Server pour l'installation du projet exemple PCRS.

- Activation du fichier de licence PCRS

Déposer le fichier de licence PCRS (pcrs_pour_fme.3rdlic) dans le répertoire de licences FME de l'installation FME Server (ex : C:\Program Files\FMEServer\Server\fme\licenses).

Pour installer l'extension PCRS sous Linux, merci de contacter notre support technique pour recevoir les ressources nécessaires à son installation (Mail : support.veremes.com - Téléphone : +33 (0)4 68 38 65 27).

## Lien entre les données source et les Writers PCRS

La première étape consiste à lire le jeu de données source PCRS dans un projet FME selon le format d'origine des données. Le système de coordonnées doit obligatoirement être renseigné dans le jeu de données source.

Les Transformers personnalisés sont ensuite intégrés au projet FME au besoin.

L'objectif est d'établir le lien entre les données source et les Transformers personnalisés.

**Exemple**

La classe "ArbrePCRS" est associée au Transformer personnalisé "PCRS_ArbrePCRS". L'utilisateur va alors relier dans FME son type d'entités source correspondant aux arbres au Transformer "PCRS_ArbrePCRS".

C'est le même principe pour l'ensemble des classes comme l'illustre la figure ci-dessous.

![](https://raw.githubusercontent.com/Veremes/doc_PCRS/master/Images/donnees_sources.PNG)

## Prétraitements des données

Parfois, les données ne sont pas exploitables directement et nécessitent un prétraitement.

C'est à l'utilisateur de gérer cette partie en retravaillant les données pour les rendre conformes aux prérequis des Transformers.

La nécessité des traitements en amont sur les types d'entités dépend de la qualité des données source.

## Paramétrer les Transformers personnalisés

Lorsque la donnée source est connectée au Transformer personnalisé, le paramétrage de ce dernier peut alors être réalisé.

A l'ouverture d'un Transformer personnalisé, plusieurs éléments sont proposés. Les champs obligatoires sont visibles en rouge.

![](https://raw.githubusercontent.com/Veremes/doc_PCRS/master/Images/transformer_facade.PNG)

La rubrique [Description du Writer PCRS pour FME](http://doc-pcrs.readthedocs.io/fr/latest/Writer_PCRS/index.html#description-du-writer-pcrs-pour-fme) donne des informations sur les classes du PCRS et liste les paramètres par Transformers, et la page [Paramètres publiés](http://doc-pcrs.readthedocs.io/fr/latest/Projet_FME/PCRS_Parametres.html#PCRS_Parametres) explique tous les paramétrages des Transformers correspondant à des paramètres publiés pour FME.

## Regroupement des différents Transformers personnalisés

Les Transformers personnalisés doivent rejoindre le Transformer nommé "PCRS_EmpriseEchangePCRS". En effet, les différents objets du PCRS sont liés à l'emprise.

Le Transformer "PCRS_MergePCRSObjects" va quant à lui regrouper l'emprise et l'ensemble des objets associés en fusionnant les éléments de XML des données entrantes.

A ce stade, un attribut dans FME contient l'ensemble du XML.

## Validation du fichier GML

Le Transformer "XMLValidator" peut être intégré pour valider le contenu de l'attribut XML en fonction des impératifs du XSD du standard.

Suite à la validation, l'attribut est renommé pour être exporté dans un fichier texte au format GML.

![](https://raw.githubusercontent.com/Veremes/doc_PCRS/master/Images/regroupement.PNG)
